#include "mapitem.h"

#include "linkablemapobj.h"
#include "ornamentedobj.h"

#include <iostream>
using namespace std;

MapItem::MapItem()
{
	lmo=NULL;
	posMode=Unused;
}

void MapItem::setRelPos (const QPointF &p)
{
	posMode=Relative;
	pos=p;
	if (lmo)
	{
		((OrnamentedObj*)lmo)->setUseRelPos (true);
		((OrnamentedObj*)lmo)->move2RelPos(p);
	}
}

void MapItem::setAbsPos (const QPointF &p)
{
	posMode=Absolute;
	pos=p;
	if (lmo) lmo->move (p);
}

void MapItem::setPositionMode (PositionMode mode)
{
	posMode=mode;
}

LinkableMapObj* MapItem::getLMO()
{
	return lmo;
}

void MapItem::setLMO(LinkableMapObj *l)
{
	lmo=l;
}

void MapItem::initLMO()
{
	if (!lmo) return;
	switch (posMode)
	{
		case Relative:	
			lmo->setRelPos (pos);
			break;
		case Absolute:	
			lmo->move (pos);
			break;
		default:
			break;
	}
}

QString MapItem::getAttr()
{
	switch (posMode)
	{
		case Relative:	
			if (lmo) pos=lmo->getRelPos();
			return
				attribut("relPosX",QString().setNum(pos.x())) +
				attribut("relPosY",QString().setNum(pos.y())); 
			break;
		case Absolute:	
			if (lmo) pos=lmo->getAbsPos();
			return
				attribut("absPosX",QString().setNum(pos.x())) +
				attribut("absPosY",QString().setNum(pos.y())); 
			break;
		default:
			return QString();
			break;
	}
}

