#include "treeeditor.h"

#include <QAction>
#include <iostream>
using namespace std;

#include "vymmodel.h"

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
TreeEditor::TreeEditor(VymModel *m)
{
	//cout << "Constructor TreeEditor "<<this<<endl;
	
	model=m;

	QAction *a;
	// Shortcuts for navigating with cursor:
    a = new QAction(tr( "Select upper object","Tree Editor" ), this);
	a->setStatusTip ( tr( "Select upper object" ));
	a->setShortcut (Qt::Key_Up );
//	a->setShortcutContext (Qt::WindowShortcut);
	a->setShortcutContext (Qt::WidgetShortcut);
//	a->setShortcutContext (Qt::WidgetWithChildrenShortcut);
	addAction (a);
    connect( a, SIGNAL( triggered() ), this, SLOT( cursorUp() ) );

    a = new QAction( tr( "Select lower object","Tree Editor" ),this);
	a->setStatusTip (tr( "Select lower object" ));
	a->setShortcut ( Qt::Key_Down );
//	a->setShortcutContext (Qt::WindowShortcut);
//	a->setShortcutContext (Qt::WidgetWithChildrenShortcut);
	a->setShortcutContext (Qt::WidgetShortcut);
	addAction (a);
    connect( a, SIGNAL( triggered() ), this, SLOT( cursorDown() ) );
}

TreeEditor::~TreeEditor()
{
	//cout <<"Destructor TreeEditor for "<<model->getMapName().toStdString()<<endl;
}

void TreeEditor::cursorUp()
{
	model->select (indexAbove (model->getSelectedIndex() ));
}

void TreeEditor::cursorDown()
{
	model->select (indexBelow (model->getSelectedIndex() ));
}

